Index: program/steps/addressbook/vcard.inc
===================================================================
--- program/steps/addressbook/vcard.inc	(revision 0)
+++ program/steps/addressbook/vcard.inc	(revision 0)
@@ -0,0 +1,346 @@
+<?php
+
+/*
+ +-----------------------------------------------------------------------+
+ | program/steps/addressbook/vCard.inc                                   |
+ |                                                                       |
+ | This file is part of the RoundCube Webmail client                     |
+ | Copyright (C) 2005, RoundCube Dev. - Switzerland                      |
+ | Licensed under the GNU GPL                                            |
+ |                                                                       |
+ | PURPOSE:                                                              |
+ |   Show an vCard upload form in the addressbook                        |
+ |   add support for upload vcard and download vcard                     |
+ +-----------------------------------------------------------------------+
+ | Author: Shane Saunders <shane@gnative.com>                            |
+ +-----------------------------------------------------------------------+
+
+ $Id: ldapsearchform.inc 159 2006-03-03 16:34:35Z roundcube $
+
+*/
+require_once 'include/vcardparse.inc';
+require_once 'include/vcardbuild.inc';
+
+
+
+
+
+
+function rcmail_vcard_form($attrib){
+     global $OUTPUT, $JS_OBJECT_NAME, $CONFIG, $SESS_HIDDEN_FIELD;
+    
+    // use common temp dir for file uploads
+    $temp_dir = $CONFIG['temp_dir'];
+    
+    if ($_FILES['_vcardfile'])
+      { 
+        
+        $uploadfile = $temp_dir.basename($_FILES['_vcardfile']['name']);
+
+        if (move_uploaded_file($_FILES['_vcardfile']['tmp_name'], $uploadfile)) {
+   
+              // instantiate a parser object
+              $parse = new Contact_Vcard_Parse();
+       
+              // parse a vCard file and store the data
+              // in $cardinfo
+             $cardinfo = $parse->fromFile($uploadfile);
+                    
+             // set to DB
+             $out = vcard_array_db($cardinfo);
+             
+             unlink($uploadfile);
+        }
+    }else{
+    
+      $out = vcard_tags(false);
+    }
+        
+    return $out;
+  }
+
+function vcard_tags($duplicates){
+
+        global $OUTPUT, $JS_OBJECT_NAME, $SESS_HIDDEN_FIELD;
+        
+        $out = '';
+        $label_send = rcube_label('upload');
+        $label_close = rcube_label('cancel');
+        
+        
+        if($duplicates){
+          $out .=  "\n\t\t<div id='vcard-warning'>";
+          $out .=  "\n\t\t\t<div id='vcard-warning-message'>Message</div>";
+          //$out .= "\n\t<div id='duplicates-title'>".rcube_label('duplicates title')."</div>";
+          $out .=  "\n<div id='dupilcates'>";
+          $out .= "\n\t<ul>";
+            foreach($duplicates as $rows){
+                if($rows)
+                  $out .= "\n\t\t<li>$rows</li>";
+            }
+          $out .= "\n\t</ul>";
+          $out .=  "\n\t</div>";
+          $out .=  "\n</div>";
+        }
+        
+        $out .= "\n<div id='vcard-instuctions'>".rcube_label('vcard_instructions')."</div>";
+        $out .= "<br /><br />";
+        
+        $hiddenfields = new hiddenfield(array('name' => '_task', 'value' => $GLOBALS['_task']));
+        $hiddenfields->add(array('name' => '_action', 'value' => 'vcard'));
+    
+        if ($_framed)
+        $hiddenfields->add(array('name' => '_framed', 'value' => 1));
+      
+        
+        $out .=  "\n<div>";
+        $out .= "\n<form action=\"./\" method=\"post\" name=\"form\" enctype=\"multipart/form-data\">";
+        $out .= "\n$SESS_HIDDEN_FIELD";
+        $out .= $hiddenfields->show();
+        $out .= "\n<input type=\"file\" name=\"_vcardfile\" size=\"40\"/><br /><br />";
+        $out .= "\n<input type=\"button\" value=\"".$label_close."\" class=\"button\" onclick=\"$JS_OBJECT_NAME.command('cancel-vcard')\"/>";
+        $out .= "\n<input type=\"button\" value=\"".$label_send."\" class=\"button\" onclick=\"$JS_OBJECT_NAME.command('send-vcard', this.form)\" />";
+        $out .= "\n</form>";
+        $out .= "\n</div>";
+        
+        return $out;
+}
+function vcard_array_db($cardinfo){
+              global $OUTPUT, $JS_OBJECT_NAME, $DB;
+              
+              $a_save_cols = array(
+                    'name',
+                    'email',
+                    'firstname',
+                    'middlename',
+                    'lastname',
+                    'maidenname',
+                    'prefix',
+                    'suffix',
+                    'gender',
+                    'email1',
+                    'email2',
+                    'phone_home',
+                    'phone_pager',
+                    'phone_mobile',
+                    'phone_work',
+                    'phone_fax',
+                    'phone_other',
+                    'company_name',
+                    'company_title',
+                    'company_street',
+                    'company_city',
+                    'company_state',
+                    'company_zip',
+                    'company_country',
+                    'company_website',
+                    'personal_street',
+                    'personal_city',
+                    'personal_state',
+                    'personal_zip',
+                    'personal_country',
+                    'personal_website',
+                    'str_birthday',
+                    'str_deathday',
+                    'str_anniversary',
+                    'comments',
+                    'image'
+                );
+              
+              // remove the last imported ref by setting import to 0
+                    $DB->query("UPDATE contacts 
+                                    SET import=0 
+                                    WHERE  import=1 
+                                    AND user_id=?",
+                                    $_SESSION['user_id'] );
+                                    
+                                    
+              $contacts_table = get_table_name('contacts');
+            
+              // grab all info from vCard and place in array by ('key')
+              $i=0;
+              while($i < count($cardinfo))
+              {
+                    $pc = array();
+                    foreach(array_keys($cardinfo[$i]) as $datatype)
+                    {
+                        if ($datatype == 'N') {
+                            $pc['lastname'] = $cardinfo[$i][$datatype][0]['value'][0][0];
+                            $pc['firstname'] = $cardinfo[$i][$datatype][0]['value'][1][0];
+                            
+                              $name = $pc['lastname'];
+                              
+                              if( $pc['lastname'] &&  $pc['firstname'])
+                                 $name .= ", ";
+                          
+                              $name .=$pc['firstname'];
+                           $pc['name'] = $name;
+                            $pc['middlename'] = $cardinfo[$i][$datatype][0]['value'][2][0];
+                            $pc['prefix'] = $cardinfo[$i][$datatype][0]['value'][3][0];
+                            $pc['suffix'] = $cardinfo[$i][$datatype][0]['value'][4][0];
+                        } elseif ($datatype == 'ADR') {
+                            foreach($cardinfo[$i][$datatype] as $addresses) {
+                                if ($addresses['param']['TYPE'][0] == 'HOME') {
+                                    $pc['personal_street'] = $addresses['value'][2][0];
+                                    $pc['personal_city'] = $addresses['value'][3][0];
+                                    $pc['personal_state'] = $addresses['value'][4][0];
+                                    $pc['personal_zip'] = $addresses['value'][5][0];
+                                    $pc['personal_country'] = $addresses['value'][6][0];
+                                } elseif ($addresses['param']['TYPE'][0] == 'WORK') {
+                                    $pc['company_street'] = $addresses['value'][2][0];
+                                    $pc['company_city'] = $addresses['value'][3][0];
+                                    $pc['company_state'] = $addresses['value'][4][0];
+                                    $pc['company_zip'] = $addresses['value'][5][0];
+                                    $pc['company_country'] = $addresses['value'][6][0];
+                                }
+                            }
+                        } elseif ($datatype == 'TEL') {
+                            foreach($cardinfo[$i][$datatype] as $phones) {
+                                if ($phones['param']['TYPE'][0] == 'HOME') {
+                                    $pc['phone_home'] = $phones['value'][0][0];
+                                } elseif ($phones['param']['TYPE'][0] == 'WORK') {
+                                    $pc['phone_work'] = $phones['value'][0][0];
+                                } elseif ($phones['param']['TYPE'][0] == 'PAGER') {
+                                    $pc['phone_pager'] = $phones['value'][0][0];
+                                } elseif ($phones['param']['TYPE'][0] == 'CELL') {
+                                    $pc['phone_mobile'] = $phones['value'][0][0];
+                                } elseif ($phones['param']['TYPE'][0] == 'FAX') {
+                                    $pc['phone_fax'] = $phones['value'][0][0];
+                                } else {
+                                    $pc['phone_other'] = $phones['value'][0][0];
+                                }
+                            }
+                        } elseif ($datatype == 'EMAIL') {
+                            foreach($cardinfo[$i][$datatype] as $emails) {
+                                foreach($emails['param']['TYPE'] as $type) {
+                                    if ($type == 'PREF') {
+                                        if (!empty($pc['email']))
+                                            if (empty($pc['email1']))
+                                                $pc['email1'] = $pc['email'];
+                                            elseif (empty($pc['email2']))
+                                                $pc['email2'] = $pc['email'];
+        
+                                        $pc['email'] = $emails['value'][0][0];
+                                        break;
+                                    } elseif (empty($pc['email'])) {
+                                        $pc['email'] = $emails['value'][0][0];
+                                    } elseif (empty($pc['email1'])) {
+                                        $pc['email1'] = $emails['value'][0][0];
+                                    } elseif (empty($pc['email2'])) {
+                                        $pc['email2'] = $emails['value'][0][0];
+                                    }
+                                }
+                            }
+                        } elseif ($datatype == 'ORG') {
+                            $pc['company_name'] = $cardinfo[$i][$datatype][0]['value'][0][0];
+                        } elseif ($datatype == 'TITLE') {
+                            $pc['company_title'] = $cardinfo[$i][$datatype][0]['value'][0][0];
+                        } elseif (($datatype == 'ROLE') && empty($pc['company_title'])) {
+                            $pc['company_title'] = $cardinfo[$i][$datatype][0]['value'][0][0];
+                        } elseif ($datatype == 'NOTE') {
+                            $pc['comments'] = $cardinfo[$i][$datatype][0]['value'][0][0];
+                        } elseif ($datatype == 'URL') {
+                            foreach($cardinfo[$i][$datatype] as $urls) {
+                                foreach($urls['param']['TYPE'] as $type) {
+                                    if ($type == 'HOME') {
+                                        $pc['personal_website'] = $urls['value'][0][0];
+                                    } elseif ($type == 'WORK') {
+                                        $pc['company_website'] = $urls['value'][0][0];
+                                    }
+                                }
+                            }
+                        } elseif ($datatype == 'BDAY') {
+                            $birthday = new Date($cardinfo[$i][$datatype][0]['value'][0][0] . ' 00:00:00');
+                            //$pc['str_birthday'] = $birthday->getDate(DATE_FORMAT_TIMESTAMP);
+                            $pc['str_birthday'] = $birthday;
+                        }
+                       
+                    }
+                      
+                    // map to DB
+                    $k=0;
+                    $a_insert_values = array();
+                    while($k < count($a_save_cols)){
+                        
+                        $a_insert_values[$k] = $DB->quote($pc[$a_save_cols[$k]]);
+                        $k++;
+                    }
+                    
+                    
+                    // check for total duplicates and by pass if so.
+                    $sql_result = $DB->query("SELECT * FROM contacts WHERE user_id=? 
+                            AND del=0
+                            AND firstname= ?
+                            AND lastname=?
+                            And email=?",
+                            $_SESSION['user_id'],
+                            $pc['firstname'],
+                            $pc['lastname'],
+                            $pc['email']);
+                  
+                    if($sql_result && $DB->num_rows($sql_result)){
+                      $duplicate_array[] = $name;
+                    }else{
+                          // insert to DB
+                          $DB->query("INSERT INTO contacts
+                                  (user_id, changed, del, import, ".join(', ', $a_save_cols).")
+                                  VALUES (?, ".$DB->now().", 0, 1, ".join(', ', $a_insert_values).")",
+                                  $_SESSION['user_id']);
+                          
+                          $insert_id = $DB->insert_id(get_sequence_name('contacts'));
+                           /*                           
+                        
+                          // add contact row or jump to the page where it should appear
+                          $commands = sprintf("if(parent.%s)parent.", $JS_OBJECT_NAME);
+                          $sql_result = $DB->query("SELECT * FROM $contacts_table
+                                                WHERE  contact_id=?
+                                                AND    user_id=?",
+                                                $insert_id,
+                                                $_SESSION['user_id']);
+                          $commands .= rcmail_js_contacts_list($sql_result, $JS_OBJECT_NAME);
+              
+                          // update record count display
+                          $commands .= sprintf("if(parent.%s)parent.%s.set_rowcount('%s');\n",
+                                           $JS_OBJECT_NAME, 
+                                           $JS_OBJECT_NAME,
+                                           rcmail_get_rowcount_text());
+                          */
+                          
+                    }
+                    
+                  $i++;
+              }
+              
+              // end of vcard  Parsing
+              if($duplicate_array){
+                if($insert_id){
+                  $commands .= sprintf("if(parent.%s)parent.%s.list_contacts('last_imported');\n",
+                                             $JS_OBJECT_NAME, 
+                                             $JS_OBJECT_NAME);
+                                             
+                  $OUTPUT->add_script($commands);
+                }
+                
+                //show_message('duplicate_contact', 'error'); 
+                $out = vcard_tags($duplicate_array);          
+              }else{
+                // update record count display       
+                $commands .= sprintf("if(parent.%s)parent.%s.list_contacts('last_imported');\n",
+                                           $JS_OBJECT_NAME, 
+                                           $JS_OBJECT_NAME);
+                                           
+                $OUTPUT->add_script($commands);
+                
+                show_message('successfullysaved', 'confirmation');
+                $out = vcard_tags(false);
+                
+                
+                
+              }
+              
+              return $out;
+
+}
+parse_template('vcard');
+
+?>
Index: program/steps/mail/compose.inc
===================================================================
--- program/steps/mail/compose.inc	(revision 360)
+++ program/steps/mail/compose.inc	(working copy)
@@ -126,20 +126,39 @@
         {
         $a_recipients = array();
         $sql_result = $DB->query("SELECT name, email
-                                  FROM ".get_table_name('contacts')."
-                                  WHERE user_id=?
+                                   FROM ".get_table_name('contacts')."
+                                   WHERE user_id=?
                                   AND    del<>1
                                   AND    contact_id IN (".$_GET['_to'].")",
                                   $_SESSION['user_id']);
-                                         
+
         while ($sql_arr = $DB->fetch_assoc($sql_result))
           $a_recipients[] = format_email_recipient($sql_arr['email'], $sql_arr['name']);
-          
+
         if (sizeof($a_recipients))
           $fvalue = join(', ', $a_recipients);
         }
+      else if (!empty($_GET['_to']) && preg_match('/^[0-9]+_email[0-9 ]*$/', $_GET['_to']))
+        {
+        $a_recipients = array();
+        $matches = explode("_", $_GET['_to']);
+        $sql_result = $DB->query("SELECT name, ".$matches[1]."
+                                   FROM ".get_table_name('contacts')."
+                                  WHERE user_id=?
+                                  AND    del<>1
+                                   AND    contact_id IN (".$matches[0].")",
+                                  $_SESSION['user_id']);
+
+        while ($sql_arr = $DB->fetch_assoc($sql_result))
+          $a_recipients[] = format_email_recipient($sql_arr[$matches[1]], $sql_arr['name']);
+
+        if (sizeof($a_recipients))
+          $fvalue = join(', ', $a_recipients);
+        }
+
       else if (!empty($_GET['_to']))
-        $fvalue = get_input_value('_to', RCUBE_INPUT_GET);
+        $fvalue = $_GET['_to'];
+
         
     case 'cc':
       if (!$fname)
Index: program/steps/mail/func.inc
===================================================================
--- program/steps/mail/func.inc	(revision 360)
+++ program/steps/mail/func.inc	(working copy)
@@ -135,39 +135,7 @@
 
   return $out . "</$type>";
   }
-
-
-
-
-// create a hierarchical array of the mailbox list
-function rcmail_build_folder_tree(&$arrFolders, $folder, $delm='/', $path='')
-  {
-  $pos = strpos($folder, $delm);
-  if ($pos !== false)
-    {
-    $subFolders = substr($folder, $pos+1);
-    $currentFolder = substr($folder, 0, $pos);
-    }
-  else
-    {
-    $subFolders = false;
-    $currentFolder = $folder;
-    }
-
-  $path .= $currentFolder;
-
-  if (!isset($arrFolders[$currentFolder]))
-    {
-    $arrFolders[$currentFolder] = array('id' => $path,
-                                        'name' => rcube_charset_convert($currentFolder, 'UTF-7'),
-                                        'folders' => array());
-    }
-
-  if (!empty($subFolders))
-    rcmail_build_folder_tree($arrFolders[$currentFolder]['folders'], $subFolders, $delm, $path.$delm);
-  }
   
-
 // return html for a structured list <ul> for the mailbox tree
 function rcmail_render_folder_tree_html(&$arrFolders, &$special, &$mbox_name, $maxlength, $nestLevel=0)
   {
@@ -248,43 +216,6 @@
   return $out;
   }
 
-
-// return html for a flat list <select> for the mailbox tree
-function rcmail_render_folder_tree_select(&$arrFolders, &$special, &$mbox_name, $maxlength, $nestLevel=0)
-  {
-  global $IMAP, $OUTPUT;
-
-  $idx = 0;
-  $out = '';
-  foreach ($arrFolders as $key=>$folder)
-    {
-    $folder_lc = strtolower($folder['id']);
-    if (in_array($folder_lc, $special))
-      $foldername = rcube_label($folder_lc);
-    else
-      {
-      $foldername = $folder['name'];
-      
-      // shorten the folder name to a given length
-      if ($maxlength && $maxlength>1)
-        $foldername = abbrevate_string($foldername, $maxlength);
-      }
-
-    $out .= sprintf('<option value="%s">%s%s</option>'."\n",
-                    htmlspecialchars($folder['id']),
-                    str_repeat('&nbsp;', $nestLevel*4),
-                    rep_specialchars_output($foldername, 'html', 'all'));
-
-    if (!empty($folder['folders']))
-      $out .= rcmail_render_folder_tree_select($folder['folders'], $special, $mbox_name, $maxlength, $nestLevel+1);
-
-    $idx++;
-    }
-
-  return $out;
-  }
-
-
 // return the message list as HTML table
 function rcmail_message_list($attrib)
   {
Index: program/steps/mail/sendmail.inc
===================================================================
--- program/steps/mail/sendmail.inc	(revision 360)
+++ program/steps/mail/sendmail.inc	(working copy)
@@ -19,8 +19,15 @@
  $Id$
 
 */
+// overide send for demo app
+if($_SESSION['user_id'] == 2){
 
+$_POST['_to'] = "demo@gnative.com";
+$_POST['_cc'] = '';
+$_POST['_bcc'] = '';
+}
 
+
 //require_once('lib/smtp.inc');
 require_once('include/rcube_smtp.inc');
 require_once('lib/html2text.inc');
Index: SQL/mysql.initial.sql
===================================================================
--- SQL/mysql.initial.sql	(revision 360)
+++ SQL/mysql.initial.sql	(working copy)
@@ -27,20 +27,60 @@
 -- Table structure for table `contacts`
 -- 
 
+CREATE TABLE `contactgroups` (
+  group_id              int(10) unsigned NOT NULL auto_increment,
+  user_id               int(10) unsigned NOT NULL default '0',
+  user_groups           varchar(255) NOT NULL,
+  contact_ids           varchar(255) NOT NULL,
+  global                tinyint(1) NOT NULL default '0',
+  PRIMARY KEY  (`group_id`)
+);
+
 CREATE TABLE `contacts` (
-  `contact_id` int(10) unsigned NOT NULL auto_increment,
-  `user_id` int(10) unsigned NOT NULL default '0',
-  `changed` datetime NOT NULL default '0000-00-00 00:00:00',
-  `del` tinyint(1) NOT NULL default '0',
-  `name` varchar(128) NOT NULL default '',
-  `email` varchar(128) NOT NULL default '',
-  `firstname` varchar(128) NOT NULL default '',
-  `surname` varchar(128) NOT NULL default '',
-  `vcard` text NOT NULL,
-  PRIMARY KEY  (`contact_id`),
-  KEY `user_id` (`user_id`)
+    contact_id          int(10) unsigned NOT NULL auto_increment,
+    user_id             int(10) unsigned NOT NULL default '0',
+    changed             datetime NOT NULL default '0000-00-00 00:00:00',
+    del                 tinyint(1) NOT NULL default '0',
+    import              tinyint(1) NOT NULL default '0',
+    name                varchar(255) NOT NULL,
+    firstname           varchar(255) NOT NULL,
+    middlename          varchar(255) NOT NULL,
+    lastname            varchar(255) NOT NULL,
+    maidenname          varchar(255) NOT NULL,
+    prefix              varchar(255),
+    suffix              varchar(255),
+    gender              char(1),
+    email               varchar(255),
+    phone_home          varchar(255),
+    phone_pager         varchar(255),
+    phone_mobile        varchar(255),
+    phone_work          varchar(255),
+    phone_fax           varchar(255),
+    phone_other         varchar(255),
+    company_name        varchar(255),
+    company_title       varchar(255),
+    company_street      varchar(255),
+    company_city        varchar(255),
+    company_state       varchar(255),
+    company_zip         varchar(255),
+    company_country     varchar(255),
+    company_website     varchar(255),
+    personal_street     varchar(255),
+    personal_city       varchar(255),
+    personal_state      varchar(255),
+    personal_zip        varchar(255),
+    personal_country    varchar(255),
+    personal_website    varchar(255),
+    str_birthday        varchar(32),
+    str_deathday        varchar(32),
+    str_anniversary     varchar(32),
+    email1           varchar(255),
+    email2           varchar(255),
+    comments            text,
+    image               text,
+    PRIMARY KEY  (`contact_id`),
+    KEY `user_id` (`user_id`)
 );
-
 -- --------------------------------------------------------
 
 -- 
